2015 ACM/ICPC Asia Regional Changchun Online(hdu 5437 - hdu 5449)

先简单说说这次网络赛吧,总而言之,还是题刷少了,思想一短路,反正是怎么爬也爬不起来了。。。心塞。。。第7题,模板题,13钟AC,手速还是慢了,接着做题二题,由于处理细节问题,01:13:56才AC,感觉自己还是要稳一点,不然做了之后,队友出几组数据,没过,又要改。。。麻烦。。。接着队友把5题暴力敲出来了,结果超时,然后我用离线做了一遍,可是,我掉坑里了,其实都是离线查找+并查集,只不过的我的方法比较笨,(具体的直接见超时代码吧),其实只要每合并两个块,直接将两个块加上,然后减去原来两个块的和就行了,然而自己是每一个点一个点的加,一直想怎么优化根结点,并没有想到状态压缩(当时,我队友还跟我提起过,我不知道当时怎么没在意这句话,现在居然记起来,我队友跟我说过这句话),总之,真是自己犯傻了。。。欲哭无力呀,如果不是这题自己想的太死了的话,然后继续做第10题(它们都说第10题是道:Lucas定理 + 中国剩余定理,网上有bin神的模板,直接拿去改就可以了。。。),可能就会进现场赛了,,然而只是如果。。。第1题(优先队列+模拟)和第8题(二叉树)分别是队友敲得。。。第5,6,10题都是赛后过得。。。

1.Alisha’s Party(优先队列+模拟)

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=5437

解题思路:

题目大意:

题目大意:Alisha有k个朋友来他家,每个朋友来是有先后次序的,Alisha会开m次门,每次都是在第t个朋友到了以后,他会邀请p个

朋友进家门,因为房间不够大,所以每次邀请所带礼物价值高的朋友先进门,如果两个朋友的礼物价值相同,则先来的先进门。最

后等所有朋友都到了以后,Alisha会把他所有的朋友都叫进来,进来的顺序跟先前的要求一样。题目给出q个询问,问第ni个进门的朋友是谁。

算法思想:

按照先后次序到来的朋友进行排序,这里可以利用优先队列把优先级最高的朋友放到队首。当开门的时候,从队首取朋友进门。同

时如果不开门的时候不断模拟朋友到来的情况,将朋友入队。最后输出答案即可。

注意:

给出的t时乱序的,需要排序,而且t有可能是相同的,比如t为3的时候,可能是3 1 ,3  2,对于这种情况,其实是将这些人邀请进入

房屋,如果门外没人了就结束了。

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>
#include <vector>
#include <algorithm>
using namespace std;

struct node{
    char name[205];
    int data;
    int pos;
    bool operator <(const node &a) const{
        if(data == a.data){
            return pos > a.pos;
        }
        return data < a.data;
    }
}no[150005];

struct open{
    int t;
    int p;
}op[150005];
int k,m,Q;
vector<int> ans;

bool cmp(struct open a, struct open b){
    return a.t < b.t;
}

void solve(){//用优先队列进行模拟
    int step = 1;
    for(int i = 2; i <= m; i++){
        if(op[i].t == op[step].t)
            op[step].p += op[i].p;
        else{
            op[++step].t = op[i].t;
            op[step].p = op[i].p;
        }
    }
    node tmp;
    priority_queue<node> q;
    int cur = 1,num;//cur当前时间,num计数
    for(int i = 1; i <= step; i++){
        num = 0;
        for(int j = cur;j <= op[i].t; j++)
            q.push(no[j]);
        cur = op[i].t + 1;
        while(!q.empty() && num < op[i].p){
            tmp = q.top();
            q.pop();
            ans.push_back(tmp.pos);
            num++;
        }
    }
    for(int i = op[step].t + 1;i <= k;++ i)
        q.push(no[i]);
    while(!q.empty()){
        tmp = q.top();
        q.pop();
        ans.push_back(tmp.pos);
    }
}

int main(){
    int T;
    scanf("%d",&T);
    while(T --){
        ans.clear();
        scanf("%d%d%d",&k,&m,&Q);
        for(int i = 1; i <= k; i++){
            scanf("%s%d",no[i].name,&no[i].data);
            no[i].pos = i;
        }
        for(int i = 1; i <= m; i++)
            scanf("%d%d",&op[i].t,&op[i].p);
        sort(op+1,op+m+1,cmp);
        solve();
        int x;//查询
        for(int i = 1; i < Q; i++){
            scanf("%d",&x);
            printf("%s ",no[ans[x-1]].name);
        }
        scanf("%d",&x);
        printf("%s\n",no[ans[x-1]].name);
    }
    return 0;
}

2.Ponds(并查集+拓扑序)

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=5438

解题思路:

题目大意:

有p个池塘,每个池塘有一个价值,他们之间有水管相连。有一个操作:如果一个池塘相连的水管少于2根,就可以将这个池塘拆

掉,然后一直重复这个操作,直到不能操作为止。问最后剩下的这些池塘组成的联通块中,块里的池塘数目为奇数的价值和。

算法思想:

利用拓扑序的思想,将能拆除的池塘,一一拆除,直到不能再被拆除为止。剩下的池塘肯定都形成了环,所以我们只要求出每个环

中所含池塘数为奇数的这些池塘价值的和。

AC代码:

#include <iostream>
#include <cstdio>
#include <vector>
#include <cstring>
using namespace std;

typedef long long ll;
int p,m;
ll a[10005];
int pa[10005];
int deg[10005];
int vis[10005];
int num[10005];
int tt[10005];
vector<int> v[10005];

int findset(int x){
    if(x == pa[x])
        return pa[x];
    return pa[x] = findset(pa[x]);
}

void topSort(){//将度数小于2的点都删去
    int flag = 1,l;
    while(flag){
        flag = 0;
        for(int i = 1; i <= p; i++){
            if(!vis[i] && deg[i] <= 1){
                vis[i] = 1;
                l = v[i].size();
                for(int j = 0; j < l; j++){
                    //cout<<v[i][j]<<endl;
                    deg[v[i][j]]--;
                }
                flag = 1;
            }
        }
    }
}

int main(){
    int T;
    scanf("%d",&T);
    while(T--){
        memset(vis,0,sizeof(vis));
        memset(deg,0,sizeof(deg));
        memset(num,0,sizeof(num));
        scanf("%d%d",&p,&m);
        for(int i = 0; i <= p; i++){
            pa[i] = i;
            v[i].clear();
        }
        for(int i = 1; i <= p; i++)
            scanf("%lld",&a[i]);
        int x,y;
        for(int i = 0; i < m; i++){
            scanf("%d%d",&x,&y);
            deg[x]++;
            deg[y]++;
            v[x].push_back(y);
            v[y].push_back(x);
            x = findset(x);
            y = findset(y);
            if(x != y)
                pa[x] = y;
        }
        topSort();
        int sum = 0;
        for(int i = 1; i <= p; i++){
            //找出所有的根节点
            if(!vis[i]){
                pa[i] = findset(i);
                num[pa[i]]++;
            }
        }
        for(int i = 1;i <= p; i++){
            //找出符合题意的根结点,即该块的结点数为奇数
            if(num[i]%2)
                tt[sum++] = i;
        }
        ll ans = 0;
        for(int i = 1; i <= p; i++){
            if(!vis[i]){
                for(int j = 0; j < sum; j++){
                    if(pa[i] == tt[j]){
                        ans += a[i];
                        break;
                    }
                }
            }
        }
        printf("%lld\n",ans);
    }
    return 0;
}

5.Travel(离线操作+并查集路径压缩)

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=5441

解题思路:

http://blog.csdn.net/piaocoder/article/details/48437701

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

struct node{
    int x,y,l;
    bool operator < (const node &a) const{
        return l < a.l;
    }
}no[100005];

struct Query{
    int id,l;
     bool operator < (const Query &a) const{
        return l < a.l;
    }
}qq[5005];
int pa[20005];
int num[20005];
int ans[5005];

int findset(int x){
    if(x == pa[x])
        return pa[x];
    return pa[x] = findset(pa[x]);
}

int main(){
    int T;
    scanf("%d",&T);
    while(T--){
        int n,m,q;
        scanf("%d%d%d",&n,&m,&q);
        for(int i = 0; i <= n; i++){
            pa[i] = i;
            num[i] = 1;
        }
        for(int i = 0; i < m; i++)
            scanf("%d%d%d",&no[i].x,&no[i].y,&no[i].l);
        for(int i = 0; i < q; i++){
            scanf("%d",&qq[i].l);
            qq[i].id = i;
        }
        sort(no,no+m);
        sort(qq,qq+q);
        int x,y,j = 0,sum = 0;
        for(int i = 0; i < q; i++){
            while(j < m && no[j].l <= qq[i].l){
                x = findset(no[j].x);
                y = findset(no[j].y);
                if(x != y){
                    sum += (num[x]+num[y])*(num[x]+num[y]-1)-num[x]*(num[x]-1)-num[y]*(num[y]-1);
                    pa[x] = y;
                    num[y] += num[x];
                }
                j++;
            }
            ans[qq[i].id] = sum;
        }
        for(int i = 0; i < q; i++)
            printf("%d\n",ans[i]);
    }
    return 0;
}

7.The Water Problem(区间最大值)

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=5443

解题思路:

求区间最大值,模板题。。。

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;

const int maxn = 1005;
struct node{
    int l,r,maxn;
}tree[maxn<<2];
int a[maxn];

void build(int m,int l,int r){
    tree[m].l = l;
    tree[m].r = r;
    if(l == r){
        tree[m].maxn = a[l];
        return ;
    }
    int mid = (l+r)>>1;
    build(m<<1,l,mid);
    build((m<<1)+1,mid+1,r);
    tree[m].maxn = max(tree[m<<1].maxn,tree[(m<<1)+1].maxn);
}

int query(int m,int l,int r){
    if(l == tree[m].l && r == tree[m].r)
        return tree[m].maxn;
    int mid = (tree[m].l+tree[m].r)>>1;
    if(r <= mid)
        return query(m<<1,l,r);
    if(l > mid)
        return query((m<<1)+1,l,r);
    return max(query(m<<1,l,mid), query((m<<1)+1,mid+1,r));
}


int main(){
    int T;
    scanf("%d",&T);
    while(T--){
        int q, l, r ,n;
        scanf("%d",&n);
        if(n == 0){
            scanf("%d",&q);
            while(q--){
                scanf("%d%d",&l,&r);
            }
            continue;
        }
        for(int  i = 1; i <= n; i++)
            scanf("%d",&a[i]);
        build(1,1,n);
        scanf("%d",&q);
        while(q--){
            scanf("%d%d",&l,&r);
            printf("%d\n",query(1,l,r));
        }
    }
    return 0;
}

8.Elven Postman(二叉树)

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=5444

解题思路:

首先将所有节点初始化,然后再边加点,边模拟路径并保存,最后再给你q个询问,依次将建树过程中,保存的路径输出即可。。。

AC代码:

#include <iostream>
#include <cstring>
#include <cstdio>
using namespace std;

const int maxn = 1010;
struct node{
    int l,r;
    int sum;
    char ans[maxn];
}tree[maxn];

void update(int id,int tmp){
    if (tmp < id){
        if (tree[id].r == 0){
            tree[id].r = tmp;
            tree[tmp].sum = id;
            strcpy(tree[tmp].ans,tree[id].ans);
            strcat(tree[tmp].ans,"E");
        }
        else{
            id = tree[id].r;
            update(id,tmp);
        }
    }
    else{
        if(tree[id].l == 0){
            tree[id].l = tmp;
            tree[id].sum = id;
            strcpy(tree[tmp].ans,tree[id].ans);
            strcat(tree[tmp].ans,"W");
        }
        else{
            id = tree[id].l;
            update(id,tmp);
        }
    }
}

int main(){
    int T;
    scanf("%d", &T);
    while(T--){
        for(int i = 0; i <= 1000; i++){
            tree[i].l = 0;
            tree[i].r = 0;
            tree[i].sum = 0;
            tree[i].ans[0] = '\0';
        }
        int n,q,root,tmp;
        scanf("%d", &n);
        scanf("%d", &root);
        tree[root].sum = -1;
        n--;
        while(n--){
            scanf("%d",&tmp);
            update(root,tmp);
        }
        scanf("%d", &q);
        while(q--){
            scanf("%d",&tmp);
            printf("%s\n",tree[tmp].ans);
        }
    }
    return 0;
}

10.Unknown Treasure(lucas定理+中国剩余定理)

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=5446

解题思路:

http://blog.csdn.net/piaocoder/article/details/48445757

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;

typedef long long ll;
const int maxn = 20;
ll a[maxn];
ll mod[maxn] ;

ll mul(ll a,ll b,ll mod){
    ll ans = 0;
    while(b){
        if(b&1)
            ans = (ans+a)%mod;
        b >>= 1;
        a = (a+a)%mod;
    }
    return ans;
}

ll quick_mod(ll a,ll b,ll m){
    ll ans = 1;
    a %= m;
    while(b){
        if(b&1)
            ans = ans * a % m;
        b >>= 1;
        a = a * a % m;
    }
    return ans;
}

ll getC(ll n, ll m,int cur){
    ll p = mod[cur];
    if(m > n)
        return 0;
    if(m > n-m)
        m = n-m;
    ll ans = 1;
    for(ll i = 1; i <= m; i++){
        ll a = (n + i - m) % p;
        ll b = i % p;
        ans = mul(ans,mul(a,quick_mod(b,p-2,p),p),p);  //p为素数,i对p的逆元可以不用扩展欧几里得进行求解  re=i^(p-2)
    }
    return ans%p;
}

ll Lucas(ll n,ll k,int cur){
    ll p = mod[cur];
    if(k == 0)
        return 1%p;
    return mul(getC(n%p,k%p,cur),Lucas(n/p,k/p,cur),p);
}

void extend_Euclid(ll a, ll b, ll &x, ll &y){
    if(b == 0){
        x = 1;
        y = 0;
        return;
    }
    extend_Euclid(b,a%b,x,y);
    ll tmp = x;
    x = y;
    y = tmp - a / b * y;
}

ll solve(ll a[],ll m[],int k){
    ll M = 1;
    ll ans = 0;
    for(int i=0; i<k; i++)
        M *= mod[i];
    for(int i=0; i<k; i++){
        ll x,y,tmp;
        ll Mi = M / m[i];
        extend_Euclid(Mi, m[i], x, y);
        if(x < 0){
            x=-x;
            tmp = mul(Mi,x,M);
            tmp = mul(tmp,a[i],M);
            tmp = -tmp;
        }
        else {
            tmp = mul(Mi,x,M);
            tmp = mul(tmp,a[i],M);
        }
        ans = (ans + tmp) % M;
    }
    while(ans < 0)
        ans += M;
    return ans;
}

int main(){
    int T;
    scanf("%d",&T);
    while(T--){
        ll n,m;
        int k;
        scanf("%lld%lld%d",&n,&m,&k);
        for(int i = 0; i < k; i++)
            scanf("%lld",&mod[i]);
        for(int i = 0;i < k; i++)
            a[i] = Lucas(n,m,i)%mod[i];
        printf("%lld\n",solve(a,mod,k));
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值